/*
 * read_rep.c --
 * Chris Hyde
 * created: 
 */

/*
 * Copyright (c) 1992 University of Idaho, Moscow, Idaho.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation free of charge for any purpose is hereby granted without
 * fee, provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of the University of Idaho
 * not be used in advertising or publicity pertaining to distribution of
 * the software without specific, written prior permission.  The University
 * of Idaho makes no representations about the suitability of this software
 * for any purpose.  It is provided "as is" without express or implied warranty.
 *
 * THE UNIVERSITY OF IDAHO DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE UNIVERSITY OF IDAHO BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
 * OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <sys/param.h>
#include <sys/file.h>
#include <sys/time.h>
#include <time.h>
#include <errno.h>
#include <pwd.h>
#include "zdbm.h"

main(int argc, char **argv)
{
 reporter_record rep_rec;
 FILE *rep_file;
 int count=1;

 if (argc<2)
 {
    fprintf(stderr, "You Must Give the Pathlist To A Reporter File.\n");
    exit(1);
 }

 if ((rep_file=open_file(argv[1], ".rep", "r", REP))==NULL)
 {
    fprintf(stderr, "Could Not Open %s.\n", argv[1]);
    exit(errno);
 }
 printf("Reporter records from the %s reporter file.\n\n", argv[1]);
 while (fread(&rep_rec, sizeof(reporter_record), 1, rep_file)!=NULL)
    printf("Reporter record %d:\n\t%s, %s, %s\n", count++, rep_rec.account_name,
		rep_rec.node_name, rep_rec.date_time);
}
 
